From 33169bdd595cc3acbcb306bddde9a28b637e8ad2 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Mar 06 2020 21:10:58 +0000
Subject: [PATCH 102/2232] Safe to assume more about the Box representation


https://doc.rust-lang.org/std/boxed/index.html:
So long as T: Sized, a Box<T> is guaranteed to be represented as a
single pointer and is also ABI-compatible with C pointers (i.e. the C
type T*).

---

diff --git a/gen/write.rs b/gen/write.rs
index 24c9c09..2bd6d3d 100644
--- a/gen/write.rs
+++ b/gen/write.rs
@@ -471,24 +471,9 @@ fn write_rust_box_extern(out: &mut OutFile, ident: &Ident) {
     );
     writeln!(
         out,
-        "void cxxbridge01$box${}$set_raw(::rust::Box<{}> *ptr, {} *raw) noexcept;",
-        instance, inner, inner
-    );
-    writeln!(
-        out,
         "void cxxbridge01$box${}$drop(::rust::Box<{}> *ptr) noexcept;",
         instance, inner,
     );
-    writeln!(
-        out,
-        "const {} *cxxbridge01$box${}$deref(const ::rust::Box<{}> *ptr) noexcept;",
-        inner, instance, inner,
-    );
-    writeln!(
-        out,
-        "{} *cxxbridge01$box${}$deref_mut(::rust::Box<{}> *ptr) noexcept;",
-        inner, instance, inner,
-    );
     writeln!(out, "#endif // CXXBRIDGE01_RUST_BOX_{}", instance);
 }
 
@@ -507,40 +492,9 @@ fn write_rust_box_impl(out: &mut OutFile, ident: &Ident) {
     writeln!(out, "}}");
 
     writeln!(out, "template <>");
-    writeln!(
-        out,
-        "void Box<{}>::set_raw({} *raw) noexcept {{",
-        inner, inner,
-    );
-    writeln!(
-        out,
-        "  return cxxbridge01$box${}$set_raw(this, raw);",
-        instance
-    );
-    writeln!(out, "}}");
-
-    writeln!(out, "template <>");
     writeln!(out, "void Box<{}>::drop() noexcept {{", inner);
     writeln!(out, "  return cxxbridge01$box${}$drop(this);", instance);
     writeln!(out, "}}");
-
-    writeln!(out, "template <>");
-    writeln!(
-        out,
-        "const {} *Box<{}>::deref() const noexcept {{",
-        inner, inner,
-    );
-    writeln!(out, "  return cxxbridge01$box${}$deref(this);", instance);
-    writeln!(out, "}}");
-
-    writeln!(out, "template <>");
-    writeln!(out, "{} *Box<{}>::deref_mut() noexcept {{", inner, inner);
-    writeln!(
-        out,
-        "  return cxxbridge01$box${}$deref_mut(this);",
-        instance
-    );
-    writeln!(out, "}}");
 }
 
 fn write_unique_ptr(out: &mut OutFile, ident: &Ident) {
diff --git a/include/cxxbridge.h b/include/cxxbridge.h
index 1ac3133..81bdad5 100644
--- a/include/cxxbridge.h
+++ b/include/cxxbridge.h
@@ -81,63 +81,60 @@ public:
   using pointer = typename std::add_pointer<value_type>::type;
 
   Box(const Box &other) : Box(*other) {}
-  Box(Box &&other) noexcept : repr(other.repr) { other.repr = 0; }
+  Box(Box &&other) noexcept : ptr(other.ptr) { other.ptr = nullptr; }
   Box(const T &val) {
     this->uninit();
-    ::new (this->deref_mut()) T(val);
+    ::new (this->ptr) T(val);
   }
   Box &operator=(const Box &other) {
     if (this != &other) {
-      if (this->repr) {
+      if (this->ptr) {
         **this = *other;
       } else {
         this->uninit();
-        ::new (this->deref_mut()) T(*other);
+        ::new (this->ptr) T(*other);
       }
     }
     return *this;
   }
   Box &operator=(Box &&other) noexcept {
-    if (this->repr) {
+    if (this->ptr) {
       this->drop();
     }
-    this->repr = other.repr;
-    other.repr = 0;
+    this->ptr = other.ptr;
+    other.ptr = nullptr;
     return *this;
   }
   ~Box() noexcept {
-    if (this->repr) {
+    if (this->ptr) {
       this->drop();
     }
   }
 
-  const T *operator->() const noexcept { return this->deref(); }
-  const T &operator*() const noexcept { return *this->deref(); }
-  T *operator->() noexcept { return this->deref_mut(); }
-  T &operator*() noexcept { return *this->deref_mut(); }
+  const T *operator->() const noexcept { return this->ptr; }
+  const T &operator*() const noexcept { return *this->ptr; }
+  T *operator->() noexcept { return this->ptr; }
+  T &operator*() noexcept { return *this->ptr; }
 
   // Important: requires that `raw` came from an into_raw call. Do not pass a
   // pointer from `new` or any other source.
   static Box from_raw(T *raw) noexcept {
     Box box;
-    box.set_raw(raw);
+    box.ptr = raw;
     return box;
   }
 
   T *into_raw() noexcept {
-    T *raw = this->deref_mut();
-    this->repr = 0;
+    T *raw = this->ptr;
+    this->ptr = nullptr;
     return raw;
   }
 
 private:
   Box() noexcept {}
   void uninit() noexcept;
-  void set_raw(pointer) noexcept;
   void drop() noexcept;
-  const_pointer deref() const noexcept;
-  pointer deref_mut() noexcept;
-  uintptr_t repr;
+  T *ptr;
 };
 #endif // CXXBRIDGE01_RUST_BOX
 
diff --git a/macro/src/expand.rs b/macro/src/expand.rs
index dd5ab6e..8519c1e 100644
--- a/macro/src/expand.rs
+++ b/macro/src/expand.rs
@@ -311,17 +311,11 @@ fn expand_rust_function_shim(namespace: &Namespace, efn: &ExternFn, types: &Type
 fn expand_rust_box(namespace: &Namespace, ident: &Ident) -> TokenStream {
     let link_prefix = format!("cxxbridge01$box${}{}$", namespace, ident);
     let link_uninit = format!("{}uninit", link_prefix);
-    let link_set_raw = format!("{}set_raw", link_prefix);
     let link_drop = format!("{}drop", link_prefix);
-    let link_deref = format!("{}deref", link_prefix);
-    let link_deref_mut = format!("{}deref_mut", link_prefix);
 
     let local_prefix = format_ident!("{}__box_", ident);
     let local_uninit = format_ident!("{}uninit", local_prefix);
-    let local_set_raw = format_ident!("{}set_raw", local_prefix);
     let local_drop = format_ident!("{}drop", local_prefix);
-    let local_deref = format_ident!("{}deref", local_prefix);
-    let local_deref_mut = format_ident!("{}deref_mut", local_prefix);
 
     let span = ident.span();
     quote_spanned! {span=>
@@ -336,32 +330,10 @@ fn expand_rust_box(namespace: &Namespace, ident: &Ident) -> TokenStream {
             );
         }
         #[doc(hidden)]
-        #[export_name = #link_set_raw]
-        unsafe extern "C" fn #local_set_raw(
-            this: *mut ::std::boxed::Box<#ident>,
-            raw: *mut #ident,
-        ) {
-            ::std::ptr::write(this, ::std::boxed::Box::from_raw(raw));
-        }
-        #[doc(hidden)]
         #[export_name = #link_drop]
         unsafe extern "C" fn #local_drop(this: *mut ::std::boxed::Box<#ident>) {
             ::std::ptr::drop_in_place(this);
         }
-        #[doc(hidden)]
-        #[export_name = #link_deref]
-        unsafe extern "C" fn #local_deref(
-            this: *const ::std::boxed::Box<::std::mem::MaybeUninit<#ident>>,
-        ) -> *const ::std::mem::MaybeUninit<#ident> {
-            &**this
-        }
-        #[doc(hidden)]
-        #[export_name = #link_deref_mut]
-        unsafe extern "C" fn #local_deref_mut(
-            this: *mut ::std::boxed::Box<::std::mem::MaybeUninit<#ident>>,
-        ) -> *mut ::std::mem::MaybeUninit<#ident> {
-            &mut **this
-        }
     }
 }
 

